/*
 * NodeBOM.java
 *
 * Created on 18 de marzo de 2005, 16:36
 */

package oracle;



/**
 *
 * @author Alejandro Touza Paredes
 */
public class NodeOracle extends Node{
    
    private Transition link;
    
    /** CONSTRUCTORAS */
    /** Crea una nueva instancia de NodeOracle */
    public NodeOracle() {
        
        super(); //llamamos al constructor del padre Node  
        link = new Transition();
        super.setType(FactorOracleConst.NODE_FINAL);
    }
    /** */
    public NodeOracle(int order) {
        
        super(order); //llamamos al constructor del padre Node(int) 
        link = new Transition();
        super.setType(FactorOracleConst.NODE_FINAL);
    }
    /** Crea una nueva instancia de Node con el Node que se le pasa*/
    public NodeOracle(NodeOracle n){
        
        this.copy(n);
    }
    
    /** MODIFICADORAS */
    public void copy(NodeOracle n){
        
        super.copy(n);
        link = new Transition();
    }
    
    /** */
    public void setLink(int start, int end){
        
        link.setValues(start, end, "");
    }
    /** */
    public void setLinkStart(int start){
        
        link.setStart(start);
    }
    /** */
    public void setLinkEnd(int end){
        
        link.setEnd(end);
    }
    
    /** CONSULTORAS */
    /** Devuelve la Transition link */
    public Transition getLink(){
        
        return link;
    }
    /** Devuelve el Nodo Origen de la Transition link */
    public int getLinkStart(){
        
        return link.getStart();
    }
    /** Devuelve el Nodo Destino de la Transition link */
    public int getLinkEnd(){
        
        return link.getEnd();
    }
    /** Si los Node source y end son los mismos retorna falso (la transiciones link
        no puede tener el mismo origen y destino */
    public boolean existsLink(){
        
        return link.getEnd() != link.getStart();
    }
    
    public void print(){
        
        super.print();
        System.out.println("## Suffix Link ##\n(" + link.getStart() + ") ---> (" + link.getEnd() + ")");
    }
    
}
